// BUAP
// FCC - Dr. Pedro Bello Lopez
import java.io.*;
import java.util.StringTokenizer;

class grafos
{
 int NN;
 int aristas;
 int origen[] = new int[100]; 
 int destino[] = new int[100]; 
 int M[][] = new int[50][50];
 
 
 public void escribematriz()
 {
 	int i,j;
 	System.out.println(" NODOS = "+NN);
 	System.out.println(" Matriz de Adyacencias");
 	System.out.print(" ");
 	for(i=1;i<=NN;i++)System.out.print("  "+i);	
 	System.out.println();
 	
 	for(i=1;i<=NN; i++)
 	{
 		System.out.print(i+"  ");
 		for (j=1;j<=NN;j++)
 		System.out.print(M[i][j]+"  ");	
 		System.out.println();
 	}
 }
 
 public void LeeGrafo(String arch) //Lee archivo con los datos del grafo
  {
  		FileInputStream fp;
		DataInputStream f;
		String linea = null;
		int token1,token2,i,j;
		aristas=0;
 try
     {
		fp = new FileInputStream(arch);
		f = new DataInputStream(fp);
		linea=f.readLine();
		
		NN=Integer.parseInt(linea); 
		System.out.println(" Numero de Nodos: "+NN);
		// Inicializamos la matriz DE ADYACENCIAS con ceros
  		for (i=1;i<=NN;i++)
  		     for(j=1;j<=NN; j++)
  		        M[i][j]=0;
  		        
  		// Leemos el archivo linea por linea
		do {
			linea = f.readLine();
			if (linea!=null){
				              StringTokenizer tokens=new StringTokenizer(linea); 
				              token1 = Integer.parseInt(tokens.nextToken());
				              token2 = Integer.parseInt(tokens.nextToken());
				              // escribimos en pantalla los datos leidos transformados en numeros
				              System.out.println(token1+" "+token2);
				              origen[aristas]=token1;
				              destino[aristas]=token2; aristas++;
				              // almacenamos en la matriz
				              M[token1][token2]=1;
				              M[token2][token1]=1;
				            }  
			}while(linea != null);
		fp.close();	
	}
	
	
         catch (FileNotFoundException exc)
         {
             System.out.println ("El archivo " + arch + " no fue encontrado ");
         }
         
         catch (IOException exc)
         {
             System.out.println (exc);
         }
  		
  }
  
  public void aloancho(int inicio)
  {
  	GraphViz gv1 = new GraphViz();
    gv1.addln(gv1.start_graph());
         
  	cola C = new cola(50); 	
	int[] visitados=new int[NN+1];
  	int n,j,padre;
  	String cad;
  	
  	for(j=0;j<=NN;j++) visitados[j]=0;
  	
    C.insertar(inicio);
    visitados[inicio]=1; 
    	  
  	while(C.vacia()!=1)
  	{  
  	   n=C.extraer(); 
  	   System.out.print(n+"->");    
  	   for(j=1;j<=NN;j++)
  	   {
  	   	if(M[n][j]!=0)
  	   	   {
  	   	    if(visitados[j]==0)
  	   	       {
  	   	         C.insertar(j);
  	   	         cad=n+"->"+j;
  	   	         gv1.addln(cad);
  	   	         visitados[j]=1;
  	   	       }       
  	   	   }
	 	}                
    }
    System.out.println();
    gv1.addln(gv1.end_graph());
    //System.out.println(gv1.getDotSource());
    String type = "jpg";
    File out = new File("recAloAncho." + type);    // Windows
    gv1.writeGraphToFile( gv1.getGraph( gv1.getDotSource(), type ), out );
  }
  
 
  public void dibujarGrafo1(String nombre)
   {
      GraphViz gv = new GraphViz();
      String cad;
      gv.addln(gv.start_NOgraph());
      
         
       for (int i=0;i<aristas;i++)
       {
       	cad=this.origen[i]+"--"+destino[i];
       	System.out.println(cad+" ");
       	gv.addln(cad);
       } 
      
               
      gv.addln(gv.end_graph());
      System.out.println(gv.getDotSource());
      
      String type = "jpg";
      File out = new File(nombre+"." + type);    // Windows
      gv.writeGraphToFile( gv.getGraph( gv.getDotSource(), type ), out );
   }
  
  
  public static void main(String[] ar)
  {
    grafos G=new grafos();
    G.LeeGrafo("entrada.dat");
    G.escribematriz();
	G.aloancho(7);
  	G.dibujarGrafo1("salida");
  }
  }